var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import require$$0, { Children, useState, useRef, useLayoutEffect, useEffect } from "react";
const KEY = {
  UP: "ArrowUp",
  DOWN: "ArrowDown",
  LEFT: "ArrowLeft",
  RIGHT: "ArrowRight",
  END: "End",
  HOME: "Home",
  PAGE_DOWN: "PageDown",
  PAGE_UP: "PageUp",
  ENTER: "Enter",
  TAB: "Tab",
  SPACE: " ",
  BACKSPACE: "Backspace",
  DELETE: "Delete",
  COMMA: ",",
  ESC: "Escape"
};
var PLACEHOLDER = /* @__PURE__ */ ((PLACEHOLDER2) => {
  PLACEHOLDER2["Id"] = "__id__";
  PLACEHOLDER2["Value"] = "__value__";
  return PLACEHOLDER2;
})(PLACEHOLDER || {});
const EmptyFunc = () => {
};
const assign = Object.assign;
const markupToRegex = (markup) => {
  const escapedMarkup = escapeRegex(markup);
  const charAfterDisplay = markup[markup.indexOf(PLACEHOLDER.Value) + PLACEHOLDER.Value.length];
  const charAfterId = markup[markup.indexOf(PLACEHOLDER.Id) + PLACEHOLDER.Id.length];
  return new RegExp(escapedMarkup.replace(PLACEHOLDER.Value, `([^${escapeRegex(charAfterDisplay || "")}]+?)`).replace(PLACEHOLDER.Id, `([^${escapeRegex(charAfterId || "")}]+?)`));
};
const makeMentionsMarkup = (markup, id, value) => {
  return markup.replace(PLACEHOLDER.Id, id).replace(PLACEHOLDER.Value, value);
};
const escapeRegex = (str) => str.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
function toString(values, children) {
  let result = "";
  let configs = Children.map(children, (child) => child);
  for (let value of values) {
    result += isMark(value) ? makeMentionsMarkup(configs[value.childIndex].props.markup, value.id, value.value) : value;
  }
  return result;
}
const genHash = (str, seed = 0) => {
  let h1 = 3735928559 ^ seed, h2 = 1103547991 ^ seed;
  for (let i = 0, ch; i < str.length; i++) {
    ch = str.charCodeAt(i);
    h1 = Math.imul(h1 ^ ch, 2654435761);
    h2 = Math.imul(h2 ^ ch, 1597334677);
  }
  h1 = Math.imul(h1 ^ h1 >>> 16, 2246822507) ^ Math.imul(h2 ^ h2 >>> 13, 3266489909);
  h2 = Math.imul(h2 ^ h2 >>> 16, 2246822507) ^ Math.imul(h1 ^ h1 >>> 13, 3266489909);
  return 4294967296 * (2097151 & h2) + (h1 >>> 0);
};
const isMark = (value) => typeof value === "object";
const useCaret = () => useState(() => new Caret())[0];
class Caret {
  constructor(_position = NaN) {
    this._position = _position;
  }
  get isBlurred() {
    return Number.isNaN(this._position);
  }
  clear() {
    this._position = NaN;
  }
  static setIndex(offset) {
    const selection = window.getSelection();
    if (!(selection == null ? void 0 : selection.anchorNode) || !selection.rangeCount)
      return;
    const range = selection.getRangeAt(0);
    range.setStart(selection.anchorNode, offset);
    range.setEnd(selection.anchorNode, offset);
  }
  static getIndex() {
    var _a;
    const selection = window.getSelection();
    return (_a = selection == null ? void 0 : selection.anchorOffset) != null ? _a : NaN;
  }
  saveRightOffset() {
    var _a, _b;
    const selection = window.getSelection();
    const position = (_b = (_a = selection == null ? void 0 : selection.anchorNode) == null ? void 0 : _a.textContent) == null ? void 0 : _b.length;
    this._position = position != null ? position : NaN;
  }
  restoreRightOffset() {
    var _a, _b, _c;
    if (this.isBlurred)
      return;
    const selection = window.getSelection();
    const range = (selection == null ? void 0 : selection.rangeCount) ? selection.getRangeAt(0) : null;
    if (!(selection == null ? void 0 : selection.anchorNode))
      return;
    let offset = ((_c = (_b = (_a = selection == null ? void 0 : selection.anchorNode) == null ? void 0 : _a.textContent) == null ? void 0 : _b.length) != null ? _c : 0) - this._position;
    range == null ? void 0 : range.setStart(selection.anchorNode, offset);
    range == null ? void 0 : range.setEnd(selection.anchorNode, offset);
    this.clear();
  }
  getCaretIndex(element) {
    let position = 0;
    const selection = window.getSelection();
    if (!(selection == null ? void 0 : selection.rangeCount))
      return position;
    const range = selection.getRangeAt(0);
    const preCaretRange = range.cloneRange();
    preCaretRange.selectNodeContents(element);
    preCaretRange.setEnd(range.endContainer, range.endOffset);
    position = preCaretRange.toString().length;
    return position;
  }
  static setCaretToEnd(element) {
    const selection = window.getSelection();
    selection == null ? void 0 : selection.setPosition(element, 1);
  }
  setCaretTo(element, offset) {
    const selection = window.getSelection();
    const range = selection == null ? void 0 : selection.getRangeAt(0);
    range == null ? void 0 : range.setStart(range.startContainer, offset);
    range == null ? void 0 : range.setEnd(range.startContainer, offset);
  }
  setCaretRightTo(element, offset) {
    const selection = window.getSelection();
    const range = selection == null ? void 0 : selection.getRangeAt(0);
    range == null ? void 0 : range.setStart(range.endContainer, offset);
    range == null ? void 0 : range.setEnd(range.endContainer, offset);
  }
}
const useHeldCaret = () => {
  const index = useRef(NaN);
  function update() {
    index.current = Caret.getIndex();
  }
  function restore() {
    Caret.setIndex(index.current);
    index.current = NaN;
  }
  useLayoutEffect(() => {
    if (Number.isNaN(index.current))
      return;
    restore();
  });
  return update;
};
const useRestoredFocus = (caret, ref) => {
  useEffect(() => {
    var _a;
    if (caret.isBlurred)
      return;
    (_a = ref.current) == null ? void 0 : _a.focus();
    caret.restoreRightOffset();
  }, []);
};
var jsxRuntime = { exports: {} };
var reactJsxRuntime_production_min = {};
/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;
function toObject(val) {
  if (val === null || val === void 0) {
    throw new TypeError("Object.assign cannot be called with null or undefined");
  }
  return Object(val);
}
function shouldUseNative() {
  try {
    if (!Object.assign) {
      return false;
    }
    var test1 = new String("abc");
    test1[5] = "de";
    if (Object.getOwnPropertyNames(test1)[0] === "5") {
      return false;
    }
    var test2 = {};
    for (var i = 0; i < 10; i++) {
      test2["_" + String.fromCharCode(i)] = i;
    }
    var order2 = Object.getOwnPropertyNames(test2).map(function(n2) {
      return test2[n2];
    });
    if (order2.join("") !== "0123456789") {
      return false;
    }
    var test3 = {};
    "abcdefghijklmnopqrst".split("").forEach(function(letter) {
      test3[letter] = letter;
    });
    if (Object.keys(Object.assign({}, test3)).join("") !== "abcdefghijklmnopqrst") {
      return false;
    }
    return true;
  } catch (err) {
    return false;
  }
}
shouldUseNative() ? Object.assign : function(target, source) {
  var from;
  var to = toObject(target);
  var symbols;
  for (var s = 1; s < arguments.length; s++) {
    from = Object(arguments[s]);
    for (var key in from) {
      if (hasOwnProperty.call(from, key)) {
        to[key] = from[key];
      }
    }
    if (getOwnPropertySymbols) {
      symbols = getOwnPropertySymbols(from);
      for (var i = 0; i < symbols.length; i++) {
        if (propIsEnumerable.call(from, symbols[i])) {
          to[symbols[i]] = from[symbols[i]];
        }
      }
    }
  }
  return to;
};
/** @license React v17.0.2
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var f = require$$0, g = 60103;
reactJsxRuntime_production_min.Fragment = 60107;
if (typeof Symbol === "function" && Symbol.for) {
  var h = Symbol.for;
  g = h("react.element");
  reactJsxRuntime_production_min.Fragment = h("react.fragment");
}
var m = f.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, n = Object.prototype.hasOwnProperty, p = { key: true, ref: true, __self: true, __source: true };
function q(c, a, k) {
  var b, d = {}, e = null, l = null;
  k !== void 0 && (e = "" + k);
  a.key !== void 0 && (e = "" + a.key);
  a.ref !== void 0 && (l = a.ref);
  for (b in a)
    n.call(a, b) && !p.hasOwnProperty(b) && (d[b] = a[b]);
  if (c && c.defaultProps)
    for (b in a = c.defaultProps, a)
      d[b] === void 0 && (d[b] = a[b]);
  return { $$typeof: g, type: c, key: e, ref: l, props: d, _owner: m.current };
}
reactJsxRuntime_production_min.jsx = q;
reactJsxRuntime_production_min.jsxs = q;
{
  jsxRuntime.exports = reactJsxRuntime_production_min;
}
const jsx = jsxRuntime.exports.jsx;
const EditableSpan = (_a) => {
  var _b = _a, {
    id,
    caret,
    onChange,
    value,
    focus
  } = _b, props = __objRest(_b, [
    "id",
    "caret",
    "onChange",
    "value",
    "focus"
  ]);
  const ref = useRef(null);
  const style = assign({
    outline: "none",
    whiteSpace: "pre-wrap"
  }, props.style);
  const held = useHeldCaret();
  focus.useManualFocus(id, ref);
  useRestoredFocus(caret, ref);
  return /* @__PURE__ */ jsx("span", {
    ref,
    style,
    className: props.className,
    contentEditable: !props.readOnly,
    suppressContentEditableWarning: true,
    onInput: (e) => {
      var _a2;
      held();
      onChange == null ? void 0 : onChange((_a2 = e.currentTarget.textContent) != null ? _a2 : "");
    },
    onFocus: (event) => {
      focus.setFocused(id);
    },
    onBlur: (event) => {
      focus.setFocused(null);
    },
    onPaste: (e) => {
      e.preventDefault();
      const text = e.clipboardData.getData("text");
      document.execCommand("insertText", false, text);
    },
    children: value
  });
};
const useSliceMap = (text, children) => {
  const slices = useSlicesOf(text);
  return useKeyMapperFor(slices);
  function useSlicesOf(text2) {
    const [slices2, setSlices] = useState([]);
    useEffect(() => {
      const configs = extractConfigs();
      const newSlices = slice(text2, configs);
      setSlices(newSlices);
    }, [text2]);
    return slices2;
    function extractConfigs() {
      return Children.map(children, (child) => child.props);
    }
    function slice(text3, configs) {
      const regExp = getCombinedRegex();
      return iterateSlices();
      function getCombinedRegex() {
        const regExps = configs.map((c) => markupToRegex(c.markup));
        return new RegExp(regExps.map((value) => value.source).join("|"));
      }
      function iterateSlices() {
        const result = [];
        let [span, mark, raw] = nextMatch(text3);
        while (mark && raw != null) {
          result.push(span, mark);
          [span, mark, raw] = nextMatch(raw);
        }
        result.push(span);
        return result;
      }
      function nextMatch(text4) {
        let match = regExp.exec(text4);
        if (!match)
          return [text4, null, null];
        let [span, mark, raw] = extractSlices(match);
        return [span, mark, raw];
      }
      function extractSlices(execArray) {
        const match = extractMatch(execArray);
        const mark = getMark(match);
        const span = match.input.substring(0, match.index);
        const raw = match.input.substring(match.index + match.annotation.length);
        return [span, mark, raw];
      }
      function extractMatch(execArray) {
        let annotation = execArray[0];
        let childIndex = 0;
        let value = execArray[1];
        let id = execArray[2];
        while (true) {
          if (value || id)
            break;
          childIndex++;
          value = execArray[2 * childIndex + 1];
          id = execArray[2 * childIndex + 2];
        }
        let index = execArray.index;
        let input = execArray.input;
        return { annotation, value, id, input, index, childIndex };
      }
      function getMark({ childIndex, id, value }) {
        const props = configs[childIndex].initializer(value, id);
        return { id, value, props, childIndex };
      }
    }
  }
  function useKeyMapperFor(slices2) {
    const [sliceMap, setSliceMap] = useState(() => /* @__PURE__ */ new Map());
    useEffect(() => {
      const newMap = slices2.reduce((map, slice) => map.set(genKey(slice, map), slice), /* @__PURE__ */ new Map());
      setSliceMap(newMap);
    }, [slices2.length]);
    return sliceMap;
    function genKey(slice, newMap) {
      let str = isMark(slice) ? slice.id + slice.value : slice;
      let seed = 0;
      let key = genHash(str, seed);
      while (newMap.has(key))
        key = genHash(str, seed++);
      return key;
    }
  }
};
const useHandleKeyDown = (caret, values, onChange, children, focus) => {
  const keys = [...values.keys()];
  const handleKeyDown = (event) => {
    var _a, _b;
    const target = event.target;
    const caretIndex = caret.getCaretIndex(target);
    const isStartCaret = caretIndex === 0;
    const isEndCaret = caretIndex === ((_a = target.textContent) == null ? void 0 : _a.length);
    const keyMap = {
      [KEY.LEFT]: isStartCaret ? onPressLeft : EmptyFunc,
      [KEY.RIGHT]: isEndCaret ? onPressRight : EmptyFunc,
      [KEY.UP]: EmptyFunc,
      [KEY.DOWN]: EmptyFunc,
      [KEY.DELETE]: EmptyFunc,
      [KEY.BACKSPACE]: isStartCaret ? onPressBackspace : EmptyFunc
    };
    (_b = keyMap[event.key]) == null ? void 0 : _b.call(keyMap, target);
  };
  const onPressLeft = (target) => {
    if (focus.focused != null) {
      let index = keys.indexOf(focus.focused);
      if (index >= 2) {
        focus.setFocused(keys[index - 2]);
        focus.isTail.current = true;
      }
    }
  };
  const onPressRight = (target) => {
    if (focus.focused != null) {
      let index = keys.indexOf(focus.focused);
      if (keys.length - index > 2) {
        focus.setFocused(keys[index + 2]);
        focus.isTail.current = false;
      }
    }
  };
  const onPressBackspace = (target) => {
    if (focus.focused != null) {
      let index = keys.indexOf(focus.focused);
      if (index >= 1) {
        caret.saveRightOffset();
        values.delete(keys[index - 1]);
        onChange(toString([...values.values()], children));
      }
    }
  };
  return handleKeyDown;
};
const useFocus = () => {
  const [focused, setFocused] = useState(null);
  const isTail = useRef(false);
  const useManualFocus = (id, ref) => useEffect(() => {
    if (id !== focused || !ref.current)
      return;
    if (isTail.current) {
      ref.current.focus();
      Caret.setCaretToEnd(ref.current);
      isTail.current = false;
      return;
    }
    ref.current.focus();
  }, [focused]);
  return {
    focused,
    setFocused,
    isTail,
    useManualFocus
  };
};
const MarkedInput = (_c) => {
  var _d = _c, {
    Mark,
    value,
    children
  } = _d, props = __objRest(_d, [
    "Mark",
    "value",
    "children"
  ]);
  const sliceMap = useSliceMap(value, children);
  const caret = useCaret();
  const focus = useFocus();
  const handleKeyDown = useHandleKeyDown(caret, sliceMap, props.onChange, children, focus);
  return /* @__PURE__ */ jsx("div", {
    className: props.className,
    style: props.style,
    onKeyDown: handleKeyDown,
    children: [...sliceMap].map(([key, value2]) => isMark(value2) ? /* @__PURE__ */ jsx(Mark, __spreadValues({
      tabIndex: -1
    }, value2.props), key) : /* @__PURE__ */ jsx(EditableSpan, {
      id: key,
      caret,
      value: value2,
      focus,
      className: props.spanClassName,
      style: props.spanStyle,
      readOnly: props.readOnly,
      onChange: (newValue) => {
        sliceMap.set(key, newValue);
        props.onChange(toString([...sliceMap.values()], children));
      }
    }, key))
  });
};
const Option = (props) => null;
export { MarkedInput, Option };
//# sourceMappingURL=rc-marked-input.es.js.map
