import { ReactElement } from "react";
import { OptionProps } from "./Option";
import { Mark } from "./types";
export declare const assign: {
    <T, U>(target: T, source: U): T & U;
    <T_1, U_1, V>(target: T_1, source1: U_1, source2: V): T_1 & U_1 & V;
    <T_2, U_2, V_1, W>(target: T_2, source1: U_2, source2: V_1, source3: W): T_2 & U_2 & V_1 & W;
    (target: object, ...sources: any[]): any;
};
export declare const markupToRegex: (markup: string) => RegExp;
export declare const makeMentionsMarkup: (markup: string, id: string, value: string) => string;
export declare const escapeRegex: (str: string) => string;
export declare function toString(values: (string | Mark<any>)[], children: ReactElement<OptionProps<any>> | ReactElement<OptionProps<any>>[]): string;
export declare const genHash: (str: string, seed?: number) => number;
export declare const genId: () => string;
export declare const isMark: (value: unknown) => value is Mark<unknown>;
/**
 * Transform annotated text to display text
 */
export declare const deannotate: () => void;
export declare const deMark: () => void;
